# pyright: reportUnusedImport=false
import struct
from typing import Optional, Self, Sequence
from .. import abcs
from ..core import Request, serialize_bytes_to
_bytes = bytes | bytearray | memoryview
def get_broadcast_stats(*, dark: bool, channel: abcs.InputChannel) -> Request[abcs.stats.BroadcastStats]:
    _buffer = bytearray(b'\x1aDB\xab')
    flags = (1 if dark else 0)
    _buffer += struct.pack('<I', flags)
    channel._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def load_async_graph(*, token: str, x: Optional[int]) -> Request[abcs.StatsGraph]:
    _buffer = bytearray(b'\xa0_\x1db')
    flags = (0 if x is None else 1)
    _buffer += struct.pack('<I', flags)
    serialize_bytes_to(_buffer, token.encode('utf-8'))
    if x is not None:
      _buffer += struct.pack(f'<q', x)
    return Request(b'' + _buffer)
def get_megagroup_stats(*, dark: bool, channel: abcs.InputChannel) -> Request[abcs.stats.MegagroupStats]:
    _buffer = bytearray(b'\x07\x86\xdf\xdc')
    flags = (1 if dark else 0)
    _buffer += struct.pack('<I', flags)
    channel._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def get_message_public_forwards(*, channel: abcs.InputChannel, msg_id: int, offset_rate: int, offset_peer: abcs.InputPeer, offset_id: int, limit: int) -> Request[abcs.messages.Messages]:
    _buffer = bytearray(b'\x1b(0V')
    channel._write_boxed_to(_buffer)
    _buffer += struct.pack('<ii', msg_id, offset_rate)
    offset_peer._write_boxed_to(_buffer)
    _buffer += struct.pack('<ii', offset_id, limit)
    return Request(b'' + _buffer)
def get_message_stats(*, dark: bool, channel: abcs.InputChannel, msg_id: int) -> Request[abcs.stats.MessageStats]:
    _buffer = bytearray(b'\xf5\xa3\xe0\xb6')
    flags = (1 if dark else 0)
    _buffer += struct.pack('<I', flags)
    channel._write_boxed_to(_buffer)
    _buffer += struct.pack('<i', msg_id)
    return Request(b'' + _buffer)
